<template>
  <v-facebook-login-scope :app-id="client_id" @login="login">
    <div
      slot-scope="scope"
      class="social-login__oauth-item social-login__oauth-item_facebook"
      @click="scope.login"
    />
  </v-facebook-login-scope>
</template>

<script>
import { VFBLoginScope as VFacebookLoginScope } from "vue-facebook-login-component";
import { mapActions } from "vuex";

import { FB_CLIENT_ID } from "../../../devAndProdVariables";

export default {
  name: "FacebookOauth",

  data: () => ({
    client_id: FB_CLIENT_ID,
  }),

  components: {
    VFacebookLoginScope,
  },

  methods: {
    ...mapActions({
      facebookOauthLogin: "facebookOauthLogin",
    }),

    async login(response) {
      let token = response.authResponse.accessToken;

      const { success } = await this.facebookOauthLogin({
        token: token,
      });

      if (success) {
        await this.$store.dispatch("popUpMessage", {
          message: "Все прошло успешно",
          type: "success",
        });
      } else {
        await this.$store.dispatch("popUpMessage", {
          message: "Что-то пошло не так. Попробуй войти через другую соц сеть",
          type: "error",
        });
      }

      this.$emit("success");
    },
  },
};
</script>
